#include <atomic>
#include <mutex>
#include <condition_variable>

using namespace std;

// Barrier implemented using atomic variables + busy waiting.
class BarrierAtomicAndBusyWaiting {
private:
    atomic<int> mFreeThreadSlots;
    atomic<int> mPhaseCounter;
    int mNumThreads;

public:
    BarrierAtomicAndBusyWaiting(int numThreads)
            : mFreeThreadSlots(numThreads), mPhaseCounter(0), mNumThreads(numThreads) {}

    void wait() {
	    // TODO:
    }
};

typedef BarrierAtomicAndBusyWaiting Barrier;
